//	ATtiny13A
//	tHggWX^

/*
|[gΉ	[ATtiny13A]	x:݂Ȃ(PB5RESET) -:
bit		7	6	5	4	3	2	1	0
portB	x	x	x	LED	-	PTr	AC1	AC0

 ~RESET/PB5 +-u-+ VCC
		PB3 |   | PB2
		PB4 |   | PB1/AIN1
		GND +---+ PB0/AIN0

q[Yrbg(avrsp.exe -rf)	oאݒ̂܂
Low: -1101010
     ||||||++-- CKSEL[1:0] VXeNbNI
     ||||++-- SUT[1:0] N
     |||+-- CKDIV8 NbNl (1:1/1, 0:1/8)
     ||+-- WDTON (WDT 0:펞ON, 1:ʏ)
     |+-- EESAVE (ChipEEPROM 0:ێ, 1:)
     +-- SPIEN (1:ISP֎~, 0:ISP) HVŜ

High:---11111
        ||||+-- RSTDISBL (RESETs 1:L, 0:(PB5))
        ||++-- BODLEVEL[1:0] (11:Off, 10:1.8V, 01:2.7V, 00:4.3V)
        |+-- DWEN (On-ChipfobO 1:, 0:L)
        +-- SPMEN (SPM 1:, 0:L)

rh
WinAVR-20080610		œKIvV:-Os
ATtiny13A	l1.2MHzi9.6MHz8jcvOCLKPRɂĕύXB


2010/05/21	v1.00	Program:     296 bytes (28.9% Full)
					Data:          2 bytes (3.1% Full)
				E
*/


#define	F_CPU	150000UL	//150kHz

#include	<avr/io.h>
#include	<avr/sleep.h>
#include	<avr/interrupt.h>
#include	<util/delay.h>


//LED_
#define	LED_SHORT_TIME	5	//(sec)
#define	LED_LONG_TIME	60	//(sec)


//|[gݒ
#define	BIT_PHTR_CTRL	(1 << PB2)
#define	BIT_LED_OUT		(1 << PB4)

//LED_
enum	E_STATUS
{
	ST_LED_SHORT,		//Zԓ_
	ST_LED_LONG,		//ԓ_
	ST_LED_LONG_END,	//ԓ_
	ST_WAIT				//ҋ@
};

//oߎԂ̃JE^
volatile	uint16_t	secCount;

//^C}^JE^荞
//0.5bƂɌĂяo
ISR(TIM0_COMPA_vect)
{
	secCount++;
}


int	main(void)
{
	uint16_t	sec;		//oߎԁibj
	uint8_t	state;			//LED̓_
	uint8_t	ledOff;			//LEDtO
	uint8_t	isLight;		//AiORp[^̔茋
	
	secCount = 0;
	state = ST_WAIT;
	
	//VXeNbNOuݒ
	CLKPR	= 0b10000000;	//NbNlύX
	CLKPR	= 0b00000110;	//64	9.6MHz/64=150kHz
	
	//|[gݒ
	DDRB	= BIT_PHTR_CTRL | BIT_LED_OUT;
	PORTB	= 0;
	
	//^C}^JE^ݒ
	//rv(CTC)	WGM02,01,00=[010]
	//CS02,01,00=[101]	1024	150kHz/1024=146.48count/sec
	TCCR0A	= (1 << WGM01) | (0 << WGM00);
	TCCR0B	= (0 << WGM02) | (1 << CS02) | (0 << CS01) | (1 << CS00);
	OCR0A	= 146 / 2;			//0.5bv
	TIMSK0	= (1 << OCIE0A);	//rvA荞
	
	//d͍팸
	ADCSRA	= (0 << ADEN);	//A/DRo[^sɂ
	DIDR0	= (1 << AIN1D) | (1 << AIN0D);	//AIN0,AIN1̃fW^͋֎~
	
	//X[v[hw
	set_sleep_mode(SLEEP_MODE_IDLE);	//̊荞ݔŕA
	sei();	//荞݋
	
	while (1)
	{
		sleep_mode();		//X[v[h˓
							//LED_ɃX[vĂLED͓_iPORTH/L͈ێj
		//ȉAȀ
		
		PORTB |= BIT_PHTR_CTRL;		//tHggWX^Jn^AIN1ɓd
		ACSR = (0 << ACD);			//AiORp[^֎~
		_delay_ms(1);				//ACPhTr̓҂iPhTrj
		isLight = (ACSR & _BV(ACO));	//邳
		ACSR = (1 << ACD);			//AiORp[^֎~iX[v̏d͍팸j
		PORTB &= ~BIT_PHTR_CTRL;	//tHggWX^~iX[v̏d͍팸j
		
		ledOff = 0;
		sec = secCount / 2;
		
		switch (state)
		{
		case ST_WAIT:	//ÂȂ̂҂Ă
			if (isLight)
			{
				ledOff = 1;		//
			}
			else
			{
				PORTB |= BIT_LED_OUT;	//_
				state = ST_LED_SHORT;	//ԑJ
			}
			break;
			
		case ST_LED_SHORT:	//Zԓ_
			if (isLight)
			{
				ledOff = 1;			//
				state = ST_WAIT;	//ԑJ
			}
			else
			{
				if (LED_SHORT_TIME <= sec)
					state = ST_LED_LONG;	//ԑJ
			}
			break;
			
		case ST_LED_LONG:	//ԓ_
			if (LED_LONG_TIME <= sec)
			{
				ledOff = 1;					//
				state = ST_LED_LONG_END;	//ԑJ
			}
			break;
			
		case ST_LED_LONG_END:	//ԓ_̖AU邭Ȃ܂ő҂Ă
			if (isLight)
				state = ST_WAIT;	//ԑJ
			break;
			
		default:	break;
		}
		
		//LED
		if (ledOff)
		{
			PORTB &= ~BIT_LED_OUT;	//
			secCount = 0;
		}
		
	}	//while()
	
	return 0;
}
